#lang racket
(require racket/runtime-path)
(define-runtime-path here ".")

(define tests 0)

(define (filename pth)
  (let-values ([(base name dir?) (split-path pth)])
    (path->bytes name)))

(for ([f (in-directory here)])
  (when (regexp-match #rx"^test-.*-hdl.rkt$" (filename f))
    (set! tests (+ 1 tests))
    (define expected (file->string (bytes->path (regexp-replace #rx".rkt$" (path->bytes f) #".ans"))))
    (define sp (open-output-string))
    (parameterize ([current-output-port sp])
      (dynamic-require f #f))
    (define got (get-output-string sp))
    (unless (equal? got expected)
      (eprintf "TEST FAILED ~a\n  ~s\n  ~s\n"
               f
               got
               expected))))

(printf "ran ~a test~a\n" tests (if (= tests 1) "" "s"))
